#include <project.h>
#include <stdio.h>
#define eepromadd 0x05;
#define eepromdata 0x75;
#define slaveid 0x5A;
#define ramadd 0x07;
uint8 Ta_ToBar=0;
void Read_Temperature(void);
void print(uint8);
uint8 i;
uint8 rdBuf[3];
uint8 wrBuf[1];



uint16 pec = 0; 
int main()
{
uint8 Uart_Data;
double tempFactor = 0.02; 
    // 0.02 degrees per LSB 
double tempData = 0x0000; 
int frac; 
uint16 data_low = 0; 
uint16 data_high = 0; 
     wrBuf[0] = 0x07;



CyGlobalIntEnable; 

I2C_1_EnableInt();
I2C_1_Start();


UART_1_Start();


 
 for(;;)
    {

    Read_Temperature();
   	


	//This converts high and low bytes together and processes temperature, 
	//MSB is a error bit and is ignored for temps 
	// This masks off the error bit of the high byte, then moves it left 8 bits and adds the low byte. 
	data_low = rdBuf[0];
	data_high = rdBuf[1];
    pec =  rdBuf[2];
	tempData = (double)(((data_high & 0x007F) << 8) + data_low); 
	tempData = (tempData * tempFactor)-0.01; 
	tempData = tempData - 273.15; 
	Uart_Data=(uint8)tempData; 
	//print(Uart_Data);
    UART_1_UartPutString("data available");
    UART_1_UartPutString("rdbuf0");
	UART_1_UartPutChar(Uart_Data);

	
	
	tempData=tempData-(int)tempData; 
    frac=tempData*100;
    UART_1_UartPutChar(frac);
	
	
        
    }
}


void Read_Temperature(void)
{

   
 I2C_1_I2CMasterWriteBuf(0x5A,wrBuf,1,I2C_1_I2C_MODE_NO_STOP);
CyDelay(1);
I2C_1_I2CMasterReadBuf(0x5A,rdBuf,3,I2C_1_I2C_MODE_REPEAT_START);
CyDelay(1);
I2C_1_I2CMasterSendStop(); 


}
/*void print(uint8 hex_data)
{
uint8 asciidata1,asciidata2;
asciidata1=hex_data/10;
asciidata1|=0x30;
asciidata2=hex_data%10;
asciidata2|=0x30;
UART_1_UartPutString("Temperature= ");

UART_1_UartPutChar(asciidata1);
UART_1_UartPutChar(asciidata2);

UART_1_UartPutChar('\n');
UART_1_UartPutChar('\r');
CyDelay(50);
}
*/

 
